/* ***** BEGIN LICENSE BLOCK *****
 * Licensed under Version: MPL 1.1/GPL 2.0/LGPL 2.1
 * Full Terms at http://mozile.mozdev.org/license.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Playsophy code.
 *
 * The Initial Developer of the Original Code is Playsophy
 * Portions created by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *		James A. Overton <james@overton.ca>
 *		Andreas Schamberger <mozile@andreass.net>
 *		Paul Everitt
 *
 * ***** END LICENSE BLOCK ***** */

/*
	Shows RSD info.
	Current user/custom save info can be seen via the save dialog window but could be added here...

*/

function mozileInfoInit(event)
{
	if (event.target != document)
		return;

	mozileSetVersionById('version');

	mozileInfoRefresh (event);
/*        
	var button = document.documentElement.getButton("extra2");
	button.setAttribute("label", document.documentElement.getAttribute("refreshlabel"));
	button.addEventListener("command", mozileInfoRefresh, true);
*/
}

function mozileInfoRefresh(event) 
{
	var f = ["info.js","mozileInfoRefresh"];

	try {
	} catch (e) {
		opener.mozileDebug(f,1,"Exception: "+e );
	}

	var mozileTarget = opener.mozileGetCurrentTarget();
	if(mozileTarget != null && mozileTarget != "") {
		try {
			//General info
			mozileSetHyperlink( "mozileLocation", mozileTarget.document.location.href );
			mozileInsertIfDesc( "mozileContentType", mozileTarget.document.contentType );
			mozileInsertIfDesc( "mozileCharacterSet", mozileTarget.document.characterSet );
			mozileInsertIfDesc( "mozileXmlEncoding", mozileTarget.document.xmlEncoding );

			if ( typeof(mozileTarget.document.MOZILE_RSD_CONFIG) != "undefined" ) {
				var rc = mozileTarget.document.MOZILE_RSD_CONFIG;
				if ( ("rsdhref" in rc) && (rc.rsdhref != "") ) {
					mozileSetHyperlink( "mozileConfigurationFile", rc.rsdhref );
					mozileSetHyperlink( "mozileMES", rc.mes );
					mozileSetHyperlink( "mozileTagView", rc.tagCSS );
					mozileInsertIfDesc( "mozilePasteMode", rc.pasteMode );
					mozileInsertIfDesc( "mozileSaveCharset", rc.saveCharset );
					mozileInsertIfDesc( "mozileSaveEntities", rc.saveEntities );
					mozileInsertIfDesc( "mozileSaveConversion", rc.saveConversion );
					mozileInsertIfDesc( "mozileSaveHTMLCase", rc.saveHTMLCase );
					mozileInsertIfDesc( "mozileSaveHTMLCompatibility", rc.saveHTMLCompatibility );
					mozileInsertIfDesc( "mozilePresetDisallow", rc.savePresetDisallow );
					mozileInsertIfDesc( "mozileContent", rc.saveContent );
					mozileInsertIfDesc( "mozileContentDisallow", rc.saveContentDisallow );
					mozileInsertIfDesc( "mozileSaveMethod", rc.saveMethod );
					mozileInsertIfDesc( "mozileSaveMethodDisallow", rc.saveMethodDisallow );
					mozileInsertIfDesc( "mozileHttpSavePath", rc.httpSavePath );
					mozileInsertIfDesc( "mozileHttpSavePathModify", rc.httpSavePathModify );
				}
			}

			if ( typeof(mozileTarget.document.MOZILE_CURRENT_CONFIG) != "undefined" ) {
				var cc = mozileTarget.document.MOZILE_CURRENT_CONFIG;
				mozileSetHyperlink( "mozileCMES", cc.mes );
				mozileSetHyperlink( "mozileCTagView", cc.tagCSS );
				mozileInsertIfDesc( "mozileCPasteMode", cc.pasteMode );
				mozileInsertIfDesc( "mozileCSaveCharset", cc.saveCharset );
				mozileInsertIfDesc( "mozileCSaveEntities", cc.saveEntities );
				mozileInsertIfDesc( "mozileCSaveConversion", cc.saveConversion );
				mozileInsertIfDesc( "mozileCSaveHTMLCase", cc.saveHTMLCase );
				mozileInsertIfDesc( "mozileCSaveHTMLCompatibility", cc.saveHTMLCompatibility );
				mozileInsertIfDesc( "mozileCPresetDisallow", cc.savePresetDisallow );
				mozileInsertIfDesc( "mozileCContent", cc.saveContent );
				mozileInsertIfDesc( "mozileCContentDisallow", cc.saveContentDisallow );
				mozileInsertIfDesc( "mozileCSaveMethod", cc.saveMethod );
				mozileInsertIfDesc( "mozileCSaveMethodDisallow", cc.saveMethodDisallow );
				mozileInsertIfDesc( "mozileCHttpSavePath", cc.httpSavePath );
				mozileInsertIfDesc( "mozileCHttpSavePathModify", cc.httpSavePathModify );
			}

		} catch(e) {
			opener.mozileDebug(f,1,"Exception: "+e );
		}
	}
	else {
		//General info of document.
		//(Could give some weird results depending on the what's open and focused???)
		var target = opener.document.commandDispatcher.focusedWindow;
		mozileSetHyperlink( "mozileLocation", target.document.location.href );
		mozileInsertIfDesc( "mozileContentType", target.document.contentType );
		mozileInsertIfDesc( "mozileCharacterSet", target.document.characterSet );
		mozileInsertIfDesc( "mozileXmlEncoding", target.document.xmlEncoding );
	}
	self.sizeToContent(); //Important to get display to update properly...
}

// Simulates a hyperlink
//
function mozileSetHyperlink ( ElemID, url ) {
	var f = ["info.js","mozileSetHyperlink"];
	try {
		var n = document.getElementById( ElemID );
		if ( url ) {
			n.value =	url;
			if ( url.substr(0,4) == "http" ) {
				n.setAttribute("class","link");
				n.setAttribute("onclick","mozileInfoOpen(this.value);");
			}
			else {
				n.removeAttribute("class");
				n.removeAttribute("onclick");
			}
		} else {
			n.value = "-";
		}
	} catch (e) {
		opener.mozileDebug(f,1,"Exception: "+e );
	}
}

// Could be improved...
// 
function mozileInfoOpen( location ) {
	if ( location ) {
		window.open( location );
	}
	return true;
}

// id = id of description node
// desc = description
//
function mozileInsertDescription( id, desc ) {
	var f = ["info.js","mozileInsertDescription"];
	try {
		var n = document.getElementById(id);
		while( n.hasChildNodes() )
			n.removeChild( n.firstChild );
		n.appendChild( document.createTextNode(desc.toString()) );
	} catch (e) {
		opener.mozileDebug(f,1,"Exception: "+e );
	}
}
function mozileInsertIfDesc( id, desc ) {
	//Convert array (of strings) to a single string, just for neatness...	
	if ( (desc && typeof(desc) == "object") /* && (desc instanceof Array) */ ) { //Firefox 1.5 bug with instanceof
		for( var i=0, Adesc=""; i < desc.length; i++ ) {
			if ( desc[i] ) {
				if (Adesc)
					Adesc += ", ";
				Adesc += desc[i].toString(); 
			}
		}
		desc = Adesc;
	}
	if(!desc)
		desc = "-";
	mozileInsertDescription( id, desc );
}

